
// LoaderM3G.java
// Andrew Davison, dandrew@fivedots.coe.psu.ac.th, November 2004

/* Display a M3G model into a simple landscape, with a mobile 
   camera for moving about.
*/

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import java.util.*;


public class LoaderM3G extends MIDlet
{
  private static final int PERIOD = 50;   // in ms

  private Timer timer;
  private LoaderCanvas loaderCanvas = null;

  public LoaderM3G()
  { timer = new Timer();  
    loaderCanvas = new LoaderCanvas(this); 
  }


  public void startApp() 
  { Display.getDisplay(this).setCurrent( loaderCanvas );
    timer.schedule( new LoaderTimer(), 0, PERIOD);   // tick every PERIOD ms
  }
  
  public void pauseApp() {}

  public void destroyApp(boolean unconditional) {}

  public void finishGame()
  { timer.cancel();    // stop the timer
    notifyDestroyed();  
  }


  // -------------------------------------------

  class LoaderTimer extends TimerTask 
  {
    public void run() 
    { if(loaderCanvas != null)
        loaderCanvas.update();   // update the scene
    }
  }

} // end of LoaderM3G class
