
// ViewM3G.java
// Andrew Davison, dandrew@fivedots.coe.psu.ac.th, November 2004

/* Load a M3G model, and print details about its scene graph
   to stdout.
   The model's scale and position can be adjusted, and the
   changes are reported to the screen.
*/

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import java.util.*;


public class ViewM3G extends MIDlet
{
  private static final int PERIOD = 50;   // in ms

  private Timer timer;
  private ViewCanvas vc = null;

  public ViewM3G()
  { timer = new Timer();  
    vc = new ViewCanvas(this); 
  }


  public void startApp() 
  { Display.getDisplay(this).setCurrent( vc );
    timer.schedule( new ViewTimer(), 0, PERIOD);   // tick every PERIOD ms
  }
  
  public void pauseApp() {}

  public void destroyApp(boolean unconditional) {}

  public void finishGame()
  { timer.cancel();    // stop the timer
    notifyDestroyed();  
  }


  // -------------------------------------------

  class ViewTimer extends TimerTask 
  {
    public void run() 
    { if(vc != null)
        vc.update();   // update the scene
    }
  }

} // end of ViewM3G class
